import modal.object
import typing
import typing_extensions

class _Queue(modal.object._StatefulObject):
    @staticmethod
    def new():
        ...

    def __init__(self):
        ...

    @staticmethod
    def persisted(label: str, namespace=1, environment_name: typing.Union[str, None] = None) -> _Queue:
        ...

    async def _get_nonblocking(self, n_values: int) -> typing.List[typing.Any]:
        ...

    async def _get_blocking(self, timeout: typing.Union[float, None], n_values: int) -> typing.List[typing.Any]:
        ...

    async def get(self, block: bool = True, timeout: typing.Union[float, None] = None) -> typing.Union[typing.Any, None]:
        ...

    async def get_many(self, n_values: int, block: bool = True, timeout: typing.Union[float, None] = None) -> typing.List[typing.Any]:
        ...

    async def put(self, v: typing.Any, block: bool = True, timeout: typing.Union[float, None] = None) -> None:
        ...

    async def put_many(self, vs: typing.List[typing.Any], block: bool = True, timeout: typing.Union[float, None] = None) -> None:
        ...

    async def _put_many_blocking(self, vs: typing.List[typing.Any], timeout: typing.Union[float, None] = None):
        ...

    async def _put_many_nonblocking(self, vs: typing.List[typing.Any]):
        ...

    async def len(self) -> int:
        ...


class Queue(modal.object.StatefulObject):
    def __init__(self):
        ...

    @staticmethod
    def new():
        ...

    @staticmethod
    def persisted(label: str, namespace=1, environment_name: typing.Union[str, None] = None) -> Queue:
        ...

    class ___get_nonblocking_spec(typing_extensions.Protocol):
        def __call__(self, n_values: int) -> typing.List[typing.Any]:
            ...

        async def aio(self, *args, **kwargs) -> typing.List[typing.Any]:
            ...

    _get_nonblocking: ___get_nonblocking_spec

    class ___get_blocking_spec(typing_extensions.Protocol):
        def __call__(self, timeout: typing.Union[float, None], n_values: int) -> typing.List[typing.Any]:
            ...

        async def aio(self, *args, **kwargs) -> typing.List[typing.Any]:
            ...

    _get_blocking: ___get_blocking_spec

    class __get_spec(typing_extensions.Protocol):
        def __call__(self, block: bool = True, timeout: typing.Union[float, None] = None) -> typing.Union[typing.Any, None]:
            ...

        async def aio(self, *args, **kwargs) -> typing.Union[typing.Any, None]:
            ...

    get: __get_spec

    class __get_many_spec(typing_extensions.Protocol):
        def __call__(self, n_values: int, block: bool = True, timeout: typing.Union[float, None] = None) -> typing.List[typing.Any]:
            ...

        async def aio(self, *args, **kwargs) -> typing.List[typing.Any]:
            ...

    get_many: __get_many_spec

    class __put_spec(typing_extensions.Protocol):
        def __call__(self, v: typing.Any, block: bool = True, timeout: typing.Union[float, None] = None) -> None:
            ...

        async def aio(self, *args, **kwargs) -> None:
            ...

    put: __put_spec

    class __put_many_spec(typing_extensions.Protocol):
        def __call__(self, vs: typing.List[typing.Any], block: bool = True, timeout: typing.Union[float, None] = None) -> None:
            ...

        async def aio(self, *args, **kwargs) -> None:
            ...

    put_many: __put_many_spec

    class ___put_many_blocking_spec(typing_extensions.Protocol):
        def __call__(self, vs: typing.List[typing.Any], timeout: typing.Union[float, None] = None):
            ...

        async def aio(self, *args, **kwargs):
            ...

    _put_many_blocking: ___put_many_blocking_spec

    class ___put_many_nonblocking_spec(typing_extensions.Protocol):
        def __call__(self, vs: typing.List[typing.Any]):
            ...

        async def aio(self, *args, **kwargs):
            ...

    _put_many_nonblocking: ___put_many_nonblocking_spec

    class __len_spec(typing_extensions.Protocol):
        def __call__(self) -> int:
            ...

        async def aio(self, *args, **kwargs) -> int:
            ...

    len: __len_spec
